Index: /palm/trunk/SOURCE/advec_s_bc.f90
===================================================================
--- /palm/trunk/SOURCE/advec_s_bc.f90	(revision 2299)
+++ /palm/trunk/SOURCE/advec_s_bc.f90	(revision 2300)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! NEC related code removed
+! 
+! 2292 2017-06-20 09:51:42Z schwenkel
 ! Implementation of new microphysic scheme: cloud_scheme = 'morrison' 
 ! includes two more prognostic equations for cloud drop concentration (nc)  
@@ -182,4 +185,6 @@
        REAL(wp) ::  im     !<
        REAL(wp) ::  ip     !<
+       REAL(wp) ::  m1n    !<
+       REAL(wp) ::  m1z    !<
        REAL(wp) ::  m2     !<
        REAL(wp) ::  m3     !<
@@ -213,15 +218,8 @@
        REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ippb !<
        REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ippe !<
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  m1   !<
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  sw   !<
        
        REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  sk_p !<
-
-#if defined( __nec )
-       REAL(sp) ::  m1n, m1z  !< important for optimisation of division
-       REAL(sp), DIMENSION(:,:), ALLOCATABLE :: m1, sw !<
-#else
-       REAL(wp) ::  m1n, m1z 
-       REAL(wp), DIMENSION(:,:), ALLOCATABLE :: m1, sw
-#endif
-
 
 !
Index: /palm/trunk/SOURCE/check_open.f90
===================================================================
--- /palm/trunk/SOURCE/check_open.f90	(revision 2299)
+++ /palm/trunk/SOURCE/check_open.f90	(revision 2300)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! -host
+! 
+! 2298 2017-06-29 09:28:18Z raasch
 ! -return_addres, return_username, avs_coor_file_..., avs_data_file_...,
 ! cross_ts_numbers, cross_ts_number_count
@@ -139,5 +142,5 @@
 
     USE control_parameters,                                                    &
-        ONLY:  coupling_char, data_output_2d_on_each_pe, host, max_masks,      &
+        ONLY:  coupling_char, data_output_2d_on_each_pe, max_masks,            &
                message_string, mid, nz_do3d, openfile, run_description_header, &
                runnr
Index: /palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- /palm/trunk/SOURCE/check_parameters.f90	(revision 2299)
+++ /palm/trunk/SOURCE/check_parameters.f90	(revision 2300)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! host-specific settings and checks removed
+! 
+! 2292 2017-06-20 09:51:42Z schwenkel
 ! Implementation of new microphysic scheme: cloud_scheme = 'morrison' 
 ! includes two more prognostic equations for cloud drop concentration (nc)  
@@ -563,12 +566,4 @@
 
 !
-!-- Warning, if host is not set
-    IF ( host(1:1) == ' ' )  THEN
-       message_string = '"host" is not set. Please check that environment ' // &
-                        'variable "localhost" & is set before running PALM'
-       CALL message( 'check_parameters', 'PA0001', 0, 0, 0, 6, 0 )
-    ENDIF
-
-!
 !-- Check the coupling mode
 !> @todo Check if any queries for other coupling modes (e.g. precursor_ocean) are missing
@@ -805,12 +800,4 @@
 !
 !-- Check the general loop optimization method
-    IF ( loop_optimization == 'default' )  THEN
-       IF ( host(1:3) == 'nec' )  THEN
-          loop_optimization = 'vector'
-       ELSE
-          loop_optimization = 'cache'
-       ENDIF
-    ENDIF
-
     SELECT CASE ( TRIM( loop_optimization ) )
 
@@ -3830,14 +3817,4 @@
 
 !
-!-- Set default value of the time needed to terminate a model run
-    IF ( termination_time_needed == -1.0_wp )  THEN
-       IF ( host(1:3) == 'ibm' )  THEN
-          termination_time_needed = 300.0_wp
-       ELSE
-          termination_time_needed = 35.0_wp
-       ENDIF
-    ENDIF
-
-!
 !-- Check pressure gradient conditions
     IF ( dp_external  .AND.  conserve_volume_flow )  THEN
Index: /palm/trunk/SOURCE/close_file.f90
===================================================================
--- /palm/trunk/SOURCE/close_file.f90	(revision 2299)
+++ /palm/trunk/SOURCE/close_file.f90	(revision 2300)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! -host
+! 
+! 2277 2017-06-12 10:47:51Z kanani
 ! Removed unused variables do2d_xy_n, do2d_xz_n, do2d_yz_n, do3d_avs_n
 ! 
@@ -79,6 +82,6 @@
 
     USE control_parameters,                                                    &
-        ONLY:  host, max_masks,                                                &
-               mid, nz_do3d, openfile, run_description_header, z_max_do2d
+        ONLY:  max_masks, mid, nz_do3d, openfile, run_description_header,      &
+               z_max_do2d
                 
     USE grid_variables,                                                        &
Index: /palm/trunk/SOURCE/disturb_field.f90
===================================================================
--- /palm/trunk/SOURCE/disturb_field.f90	(revision 2299)
+++ /palm/trunk/SOURCE/disturb_field.f90	(revision 2300)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! NEC related code removed
+! 
+! 2233 2017-05-30 18:08:54Z suehring
 !
 ! 2232 2017-05-30 17:47:52Z suehring
@@ -165,12 +168,7 @@
           DO  j = dist_nys(dist_range), dist_nyn(dist_range)
              DO  k = disturbance_level_ind_b, disturbance_level_ind_t
-#if defined( __nec )
-                randomnumber = 3.0_wp * disturbance_amplitude *                &
-                               ( RANDOM( 0 ) - 0.5_wp )
-#else
                 CALL RANDOM_NUMBER( randomnumber )
                 randomnumber = 3.0_wp * disturbance_amplitude *                &
                                 ( randomnumber - 0.5_wp )
-#endif
                 IF ( nxl <= i .AND. nxr >= i .AND. nys <= j .AND. nyn >= j )   &
                 THEN
Index: /palm/trunk/SOURCE/fft_xy_mod.f90
===================================================================
--- /palm/trunk/SOURCE/fft_xy_mod.f90	(revision 2299)
+++ /palm/trunk/SOURCE/fft_xy_mod.f90	(revision 2300)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! NEC related code partly removed, host replaced by loop_optimization
+! 
+! 2274 2017-06-09 13:27:48Z Giersch
 ! Changed error messages
 ! 
@@ -1538,4 +1541,5 @@
        INTEGER(iwp) ::  k     !<
        INTEGER(iwp) ::  siza  !<
+       INTEGER(iwp) ::  sizw  !< required on NEC only
 
        REAL(wp), DIMENSION(0:nx,nz)       ::  ar     !<
@@ -1543,9 +1547,5 @@
        REAL(wp), DIMENSION(6*(nx+4),nz+1) ::  work1  !<
        
-#if defined( __nec )
-       INTEGER(iwp) ::  sizw  !<
-       
-       COMPLEX(wp), DIMENSION((nx+4)/2+1,nz+1) ::  work  !<
-#endif
+       COMPLEX(wp), DIMENSION(:,:), ALLOCATABLE ::  work  !< required on NEC only
 
        IF ( fft_method == 'temperton-algorithm' )  THEN
@@ -1591,4 +1591,5 @@
 
 #if defined( __nec )
+          ALLOCATE( work((nx+4)/2+1,nz+1) )
           siza = SIZE( ai, 1 )
           sizw = SIZE( work, 1 )
@@ -1645,4 +1646,5 @@
           ENDIF
 
+          DEALLOCATE( work )
 #else
           message_string = 'no system-specific fft-call available'
@@ -1680,4 +1682,5 @@
        INTEGER(iwp) ::  ny1   !<
        INTEGER(iwp) ::  siza  !<
+       INTEGER(iwp) ::  sizw  !< required on NEC only
 
        REAL(wp), DIMENSION(0:ny1,nz)      ::  ar     !<
@@ -1685,9 +1688,6 @@
        REAL(wp), DIMENSION(6*(ny+4),nz+1) ::  work1  !<
        
-#if defined( __nec )
-       INTEGER(iwp) ::  sizw  !<
-       
-       COMPLEX(wp), DIMENSION((ny+4)/2+1,nz+1) ::  work !<
-#endif
+       COMPLEX(wp), DIMENSION(:,:), ALLOCATABLE ::  work !< required on NEC only
+
 
        IF ( fft_method == 'temperton-algorithm' )  THEN
@@ -1733,4 +1733,5 @@
 
 #if defined( __nec )
+          ALLOCATE( work((ny+4)/2+1,nz+1) )
           siza = SIZE( ai, 1 )
           sizw = SIZE( work, 1 )
@@ -1787,4 +1788,5 @@
           ENDIF
 
+          DEALLOCATE( work )
 #else
           message_string = 'no system-specific fft-call available'
Index: /palm/trunk/SOURCE/header.f90
===================================================================
--- /palm/trunk/SOURCE/header.f90	(revision 2299)
+++ /palm/trunk/SOURCE/header.f90	(revision 2300)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! host-specific code removed
+! 
+! 2299 2017-06-29 10:14:38Z maronga
 ! Modified output for spinups
 ! 
@@ -537,10 +540,6 @@
                           threads_per_task, pdims(1), pdims(2), TRIM( char1 )
     ENDIF
-    IF ( ( host(1:3) == 'ibm'  .OR.  host(1:3) == 'nec'  .OR.    &
-           host(1:2) == 'lc'   .OR.  host(1:3) == 'dec' )  .AND. &
-         npex == -1  .AND.  pdims(2) == 1 )                      &
-    THEN
-       WRITE ( io, 106 )
-    ELSEIF ( pdims(2) == 1 )  THEN
+
+    IF ( pdims(2) == 1 )  THEN
        WRITE ( io, 107 )  'x'
     ELSEIF ( pdims(1) == 1 )  THEN
@@ -1953,6 +1952,4 @@
               35X,'Processor grid (x,y): (',I4,',',I4,')',1X,A)
 105 FORMAT (35X,'One additional PE is used to handle'/37X,'the dvrp output!')
-106 FORMAT (35X,'A 1d-decomposition along x is forced'/ &
-            35X,'because the job is running on an SMP-cluster')
 107 FORMAT (35X,'A 1d-decomposition along ',A,' is used')
 108 FORMAT (35X,'Max. # of parallel I/O streams is ',I5)
Index: /palm/trunk/SOURCE/init_dvrp.f90
===================================================================
--- /palm/trunk/SOURCE/init_dvrp.f90	(revision 2299)
+++ /palm/trunk/SOURCE/init_dvrp.f90	(revision 2300)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! NEC related cpp directives removed
+! 
+! 2298 2017-06-29 09:28:18Z raasch
 ! MPI2 related part removed
 ! 
@@ -849,7 +852,5 @@
        CALL DVRP_LOG_EVENT( -1, 1 )   ! Logging of total cpu-time used by PALM
        IF ( use_seperate_pe_for_dvrp_output )  THEN
-#ifndef __nec
           CALL DVRP_SPLIT_EXIT( 1 )      ! Argument 0: reduced output
-#endif
        ELSE
           CALL DVRP_LOG_EXIT( 1 )        ! Argument 0: reduced output
Index: /palm/trunk/SOURCE/init_pegrid.f90
===================================================================
--- /palm/trunk/SOURCE/init_pegrid.f90	(revision 2299)
+++ /palm/trunk/SOURCE/init_pegrid.f90	(revision 2300)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! host-specific settings removed
+! 
+! 2298 2017-06-29 09:28:18Z raasch
 ! MPI2 related parts removed
 ! 
@@ -193,5 +196,5 @@
         ONLY:  bc_lr, bc_ns, coupling_mode, coupling_mode_remote,              &
                coupling_topology, gathered_size, grid_level,                   &
-               grid_level_count, host, inflow_l, inflow_n, inflow_r, inflow_s, &
+               grid_level_count, inflow_l, inflow_n, inflow_r, inflow_s,       &
                io_blocks, io_group, maximum_grid_level,                        &
                maximum_parallel_io_streams, message_string,                    &
@@ -315,9 +318,4 @@
 
 !
-!-- For communication speedup, set barriers in front of collective
-!-- communications by default on SGI-type systems
-    IF ( host(3:5) == 'sgi' )  collective_wait = .TRUE.
-
-!
 !-- If necessary, set horizontal boundary conditions to non-cyclic
     IF ( bc_lr /= 'cyclic' )  cyclic(1) = .FALSE.
Index: /palm/trunk/SOURCE/modules.f90
===================================================================
--- /palm/trunk/SOURCE/modules.f90	(revision 2299)
+++ /palm/trunk/SOURCE/modules.f90	(revision 2300)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! default value for host changed to '????', default value for loop_optimization
+! changed to 'cache', default value for termination_time_needed set to 35.0
+! 
+! 2298 2017-06-29 09:28:18Z raasch
 ! missing variable descriptions have been added,
 ! type of write_binary changed from CHARACTER to LOGICAL
@@ -950,5 +954,5 @@
     CHARACTER (LEN=12)   ::  user_interface_required_revision = ' '       !< required user-interface revision number
     CHARACTER (LEN=16)   ::  conserve_volume_flow_mode = 'default'        !< namelist parameter
-    CHARACTER (LEN=16)   ::  loop_optimization = 'default'                !< namelist parameter
+    CHARACTER (LEN=16)   ::  loop_optimization = 'cache'                  !< namelist parameter
     CHARACTER (LEN=16)   ::  momentum_advec = 'ws-scheme'                 !< namelist parameter
     CHARACTER (LEN=16)   ::  psolver = 'poisfft'                          !< namelist parameter
@@ -981,5 +985,5 @@
     CHARACTER (LEN=20)   ::  timestep_scheme = 'runge-kutta-3'            !< namelist parameter       
     CHARACTER (LEN=40)   ::  topography = 'flat'                          !< namelist parameter 
-    CHARACTER (LEN=64)   ::  host = ' '                                   !< hostname on which PALM is running, ENVPAR namelist parameter provided by mrun
+    CHARACTER (LEN=64)   ::  host = '????'                                !< hostname on which PALM is running, ENVPAR namelist parameter provided by mrun
     CHARACTER (LEN=80)   ::  log_message                                  !< user-defined message for debugging (sse data_log.f90)
     CHARACTER (LEN=80)   ::  run_identifier                               !< run identifier as given by mrun option -d, ENVPAR namelist parameter provided by mrun
@@ -1337,5 +1341,5 @@
     REAL(wp) ::  s_surface = 0.0_wp                            !< namelist parameter
     REAL(wp) ::  s_surface_initial_change = 0.0_wp             !< namelist parameter
-    REAL(wp) ::  termination_time_needed = -1.0_wp             !< namelist parameter
+    REAL(wp) ::  termination_time_needed = 35.0_wp             !< namelist parameter
     REAL(wp) ::  time_coupling = 0.0_wp                        !< time since last coupling (surface_coupler)
     REAL(wp) ::  time_disturb = 0.0_wp                         !< time since last flow disturbance
Index: /palm/trunk/SOURCE/poisfft_mod.f90
===================================================================
--- /palm/trunk/SOURCE/poisfft_mod.f90	(revision 2299)
+++ /palm/trunk/SOURCE/poisfft_mod.f90	(revision 2300)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! settings depending on host variable removed or replaced by loop_optimization
+! 
+! 2119 2017-01-17 16:51:50Z raasch
 !
 ! 2118 2017-01-17 16:38:49Z raasch
@@ -715,7 +718,6 @@
     SUBROUTINE ffty_tr_yx( f_in, f_out )
 
-
        USE control_parameters,                                                 &
-           ONLY:  host
+           ONLY:  loop_optimization
 
        USE cpulog,                                                             &
@@ -737,11 +739,10 @@
        INTEGER(iwp), PARAMETER ::  stridex = 4  !<
 
-       REAL(wp), DIMENSION(0:ny,stridex)        ::  work_ffty      !<
-#if defined( __nec )
-       REAL(wp), DIMENSION(0:ny+1,1:nz,nxl:nxr) ::  work_ffty_vec  !<
-#endif
        REAL(wp), DIMENSION(1:nz,0:ny,nxl:nxr)             ::  f_in   !<
        REAL(wp), DIMENSION(nnx,1:nz,nys_x:nyn_x,pdims(1)) ::  f_out  !<
        REAL(wp), DIMENSION(nxl:nxr,1:nz,0:ny)             ::  work   !<
+
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE   ::  work_ffty      !<
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  work_ffty_vec  !<
 
 !
@@ -751,10 +752,11 @@
        CALL cpu_log( log_point_s(7), 'fft_y_1d', 'start' )
 
-       IF ( host(1:3) == 'nec' )  THEN
-#if defined( __nec )
+       IF ( loop_optimization == 'vector' )  THEN
+
+          ALLOCATE( work_ffty_vec(0:ny+1,1:nz,nxl:nxr) )
 !
 !--       Code optimized for vector processors
-!$OMP     PARALLEL PRIVATE ( i, j, k )
-!$OMP     DO
+          !$OMP PARALLEL PRIVATE ( i, j, k )
+          !$OMP DO
           DO  i = nxl, nxr
 
@@ -769,5 +771,5 @@
           ENDDO
 
-!$OMP     DO
+          !$OMP DO
           DO  k = 1, nz
              DO  j = 0, ny
@@ -777,15 +779,17 @@
              ENDDO
           ENDDO
-!$OMP     END PARALLEL
-#endif
+          !$OMP END PARALLEL
+
+          DEALLOCATE( work_ffty_vec )
 
        ELSE
-
 !
 !--       Cache optimized code.
+          ALLOCATE( work_ffty(0:ny,stridex) )
+!
 !--       The i-(x-)direction is split into a strided outer loop and an inner
 !--       loop for better cache performance
-!$OMP     PARALLEL PRIVATE (i,iend,iouter,ir,j,k,work_ffty)
-!$OMP     DO
+          !$OMP PARALLEL PRIVATE (i,iend,iouter,ir,j,k,work_ffty)
+          !$OMP DO
           DO  iouter = nxl, nxr, stridex
 
@@ -817,7 +821,10 @@
 
           ENDDO
-!$OMP     END PARALLEL
+          !$OMP END PARALLEL
+
+          DEALLOCATE( work_ffty )
 
        ENDIF
+
        CALL cpu_log( log_point_s(7), 'fft_y_1d', 'pause' )
 
@@ -844,7 +851,6 @@
     SUBROUTINE tr_xy_ffty( f_in, f_out )
 
-
        USE control_parameters,                                                 &
-           ONLY:  host
+           ONLY:  loop_optimization
 
        USE cpulog,                                                             &
@@ -866,11 +872,10 @@
        INTEGER(iwp), PARAMETER ::  stridex = 4  !<
 
-       REAL(wp), DIMENSION(0:ny,stridex)        ::  work_ffty      !<
-#if defined( __nec )
-       REAL(wp), DIMENSION(0:ny+1,1:nz,nxl:nxr) ::  work_ffty_vec  !<
-#endif
        REAL(wp), DIMENSION(nnx,1:nz,nys_x:nyn_x,pdims(1)) ::  f_in   !<
        REAL(wp), DIMENSION(1:nz,0:ny,nxl:nxr)             ::  f_out  !<
        REAL(wp), DIMENSION(nxl:nxr,1:nz,0:ny)             ::  work   !<
+
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE   ::  work_ffty         !<
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  work_ffty_vec     !<
 
 !
@@ -890,10 +895,11 @@
        CALL cpu_log( log_point_s(7), 'fft_y_1d', 'continue' )
 
-       IF ( host(1:3) == 'nec' )  THEN
-#if defined( __nec )
+       IF ( loop_optimization == 'vector' )  THEN
+
+          ALLOCATE( work_ffty_vec(0:ny+1,1:nz,nxl:nxr) )
 !
 !--       Code optimized for vector processors
-!$OMP     PARALLEL PRIVATE ( i, j, k )
-!$OMP     DO
+          !$OMP PARALLEL PRIVATE ( i, j, k )
+          !$OMP DO
           DO  k = 1, nz
              DO  j = 0, ny
@@ -904,5 +910,5 @@
           ENDDO
 
-!$OMP     DO
+          !$OMP DO
           DO  i = nxl, nxr
 
@@ -916,15 +922,17 @@
 
           ENDDO
-!$OMP     END PARALLEL
-#endif
+          !$OMP END PARALLEL
+
+          DEALLOCATE( work_ffty_vec )
 
        ELSE
-
 !
 !--       Cache optimized code.
+          ALLOCATE( work_ffty(0:ny,stridex) )
+!
 !--       The i-(x-)direction is split into a strided outer loop and an inner
 !--       loop for better cache performance
-!$OMP     PARALLEL PRIVATE ( i, iend, iouter, ir, j, k, work_ffty )
-!$OMP     DO
+          !$OMP PARALLEL PRIVATE ( i, iend, iouter, ir, j, k, work_ffty )
+          !$OMP DO
           DO  iouter = nxl, nxr, stridex
 
@@ -955,5 +963,7 @@
 
           ENDDO
-!$OMP     END PARALLEL
+          !$OMP END PARALLEL
+
+          DEALLOCATE( work_ffty )
 
        ENDIF
@@ -976,7 +986,6 @@
     SUBROUTINE fftx_tri_fftx( ar )
 
-
        USE control_parameters,                                                 &
-           ONLY:  host
+           ONLY:  loop_optimization
 
        USE cpulog,                                                             &
@@ -1016,5 +1025,5 @@
 !$        tn = omp_get_thread_num()
 
-          IF ( host(1:3) == 'nec' )  THEN
+          IF ( loop_optimization == 'vector' )  THEN
 !
 !--          Code optimized for vector processors
@@ -1060,5 +1069,5 @@
           CALL tridia_1dd( ddx2, ddy2, nx, ny, j, work_trix, tri(:,:,:,tn) )
 
-          IF ( host(1:3) == 'nec' )  THEN
+          IF ( loop_optimization == 'vector' )  THEN
 !
 !--          Code optimized for vector processors
@@ -1123,5 +1132,5 @@
 
        USE control_parameters,                                                 &
-           ONLY:  host
+           ONLY:  loop_optimization
 
        USE cpulog,                                                             &
@@ -1149,5 +1158,5 @@
        CALL cpu_log( log_point_s(4), 'fft_x_1d', 'start' )
 
-       IF ( host(1:3) == 'nec' )  THEN
+       IF ( loop_optimization == 'vector' )  THEN
 !
 !--       Code for vector processors
@@ -1236,5 +1245,5 @@
 
        USE control_parameters,                                                 &
-           ONLY:  host
+           ONLY:  loop_optimization
 
        USE cpulog,                                                             &
@@ -1273,5 +1282,5 @@
        CALL cpu_log( log_point_s(4), 'fft_x_1d', 'continue' )
 
-       IF ( host(1:3) == 'nec' )  THEN
+       IF ( loop_optimization == 'vector' )  THEN
 !
 !--       Code optimized for vector processors
@@ -1349,5 +1358,5 @@
 
        USE control_parameters,                                                 &
-           ONLY:  host
+           ONLY:  loop_optimization
 
        USE cpulog,                                                             &
@@ -1387,5 +1396,5 @@
 !$        tn = omp_get_thread_num()
 
-          IF ( host(1:3) == 'nec' )  THEN
+          IF ( loop_optimization == 'vector' )  THEN
 !
 !--          Code optimized for vector processors
@@ -1431,5 +1440,5 @@
           CALL tridia_1dd( ddy2, ddx2, ny, nx, i, work_triy, tri(:,:,:,tn) )
 
-          IF ( host(1:3) == 'nec' )  THEN
+          IF ( loop_optimization == 'vector' )  THEN
 !
 !--          Code optimized for vector processors
Index: /palm/trunk/SOURCE/temperton_fft_mod.f90
===================================================================
--- /palm/trunk/SOURCE/temperton_fft_mod.f90	(revision 2299)
+++ /palm/trunk/SOURCE/temperton_fft_mod.f90	(revision 2300)
@@ -9,4 +9,7 @@
 ! -----------------
 ! $Id$
+! NEC related CPP directives removed
+! 
+! 1851 2016-04-08 13:32:50Z maronga
 !
 ! 1850 2016-04-08 13:29:27Z maronga
@@ -51,16 +54,9 @@
 
 
-    INTEGER(iwp)          ::  nfax(10)   !< array used by *fft991*.
+    INTEGER(iwp)            ::  nfax(10)    !< array used by *fft991*.
+    INTEGER(iwp), PARAMETER ::  nfft =  32  !< maximum length of calls to *fft
+    INTEGER(iwp), PARAMETER ::  nout =   6  !< standard output stream
+
     REAL(wp), ALLOCATABLE ::  trig(:)    !< array used by *fft991*.
-
-!
-!-- nfft: maximum length of calls to *fft.
-#if defined( __nec )
-    INTEGER(iwp), PARAMETER ::  nfft = 256  !< 
-#else
-    INTEGER(iwp), PARAMETER ::  nfft =  32  !< 
-#endif
-
-    INTEGER(iwp), PARAMETER ::  nout =   6  !< standard output stream
 
 CONTAINS