Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 2317)
+++ palm/trunk/SOURCE/Makefile	(revision 2318)
@@ -20,9 +20,12 @@
 # Current revisions:
 # ------------------
-# Add further dependencies on surface_mod
+# 
 # 
 # Former revisions:
 # -----------------
 # $Id$
+# Add further dependencies on surface_mod
+# 
+# 2317 2017-07-20 17:27:19Z suehring
 # Added time_integration_spinup
 # 
Index: palm/trunk/SOURCE/init_grid.f90
===================================================================
--- palm/trunk/SOURCE/init_grid.f90	(revision 2317)
+++ palm/trunk/SOURCE/init_grid.f90	(revision 2318)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! -----------------
-! Get topography top index via Function call 
+! 
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Get topography top index via Function call 
+! 
+! 2317 2017-07-20 17:27:19Z suehring
 ! Bugfixes in reading 3D topography from file
 ! 
Index: palm/trunk/SOURCE/lpm_advec.f90
===================================================================
--- palm/trunk/SOURCE/lpm_advec.f90	(revision 2317)
+++ palm/trunk/SOURCE/lpm_advec.f90	(revision 2318)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! ------------------
-! Get topography top index via Function call 
+! 
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Get topography top index via Function call 
+! 
+! 2317 2017-07-20 17:27:19Z suehring
 !
 ! 2232 2017-05-30 17:47:52Z suehring
Index: palm/trunk/SOURCE/lpm_boundary_conds.f90
===================================================================
--- palm/trunk/SOURCE/lpm_boundary_conds.f90	(revision 2317)
+++ palm/trunk/SOURCE/lpm_boundary_conds.f90	(revision 2318)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! -----------------
-! Get topography top index via Function call 
+! 
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Get topography top index via Function call 
+! 
+! 2317 2017-07-20 17:27:19Z suehring
 !
 ! 2232 2017-05-30 17:47:52Z suehring
Index: palm/trunk/SOURCE/lpm_init.f90
===================================================================
--- palm/trunk/SOURCE/lpm_init.f90	(revision 2317)
+++ palm/trunk/SOURCE/lpm_init.f90	(revision 2318)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! -----------------
-! Get topography top index via Function call 
-!
+! 
+! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Get topography top index via Function call 
+!
+! 2317 2017-07-20 17:27:19Z suehring
 ! Extended particle data type. Aerosol initialization improved.
 !
Index: palm/trunk/SOURCE/microphysics_mod.f90
===================================================================
--- palm/trunk/SOURCE/microphysics_mod.f90	(revision 2317)
+++ palm/trunk/SOURCE/microphysics_mod.f90	(revision 2318)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! ------------------
-! Get topography top index via Function call 
-!
+! 
+! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Get topography top index via Function call 
+!
+! 2317 2017-07-20 17:27:19Z suehring
 ! s1 changed to log_sigma
 !
Index: palm/trunk/SOURCE/plant_canopy_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 2317)
+++ palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 2318)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! -----------------
-! Get topography top index via Function call 
+! 
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Get topography top index via Function call 
+! 
+! 2317 2017-07-20 17:27:19Z suehring
 ! Changed error messages
 ! 
Index: palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 2317)
+++ palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 2318)
@@ -21,9 +21,12 @@
 ! Current revisions:
 ! ------------------
-! Get topography top index via Function call 
+! 
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Get topography top index via Function call 
+! 
+! 2317 2017-07-20 17:27:19Z suehring
 ! Set bottom boundary condition after anterpolation.
 ! Some variable description added.
Index: palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/radiation_model_mod.f90	(revision 2317)
+++ palm/trunk/SOURCE/radiation_model_mod.f90	(revision 2318)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! -----------------
-! Get topography top index via Function call 
+! 
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Get topography top index via Function call 
+! 
+! 2317 2017-07-20 17:27:19Z suehring
 ! Improved syntax layout
 ! 
Index: palm/trunk/SOURCE/surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_mod.f90	(revision 2317)
+++ palm/trunk/SOURCE/surface_mod.f90	(revision 2318)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! ------------------
-! New function to obtain topography top index. 
+! 
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! New function to obtain topography top index. 
+! 
+! 2317 2017-07-20 17:27:19Z suehring
 ! Implementation of new microphysic scheme: cloud_scheme = 'morrison' 
 ! includes two more prognostic equations for cloud drop concentration (nc)  
Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2317)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2318)
@@ -21,9 +21,12 @@
 ! Current revisions:
 ! ------------------
-! Get topography top index via Function call 
+! 
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Get topography top index via Function call 
+! 
+! 2317 2017-07-20 17:27:19Z suehring
 ! Bugfix: adjust output of shf. Added support for spinups
 ! 